local ffi = require("ffi")
ffi.cdef[[
  void* malloc(size_t);
  void free(void*);
]]
local C = ffi.C
local sendChannel
local resultChannel
function sendBuffer()
  local n = 100
  local ptr = C.malloc(n)
  local charptr = ffi.cast("char *", ptr)
  for i=0,n-1 do
    charptr[i] = i
  end
  local intptr = ffi.cast("intptr_t", charptr)
  sendChannel:push(tonumber(intptr))
end

local thread

function love.load()
  love.window.setMode(800,600, {vsync=false})
  sendChannel = love.thread.getChannel("params")
  resultChannel = love.thread.getChannel("results")
	
  thread = love.thread.newThread("thread.lua")
  thread:start()
end

function love.update()
  for i=1,1000 do
    sendBuffer()
  end
end

function love.draw()
  if thread:getError() then
    error("thread error:" ..thread:getError())
  end
  love.graphics.print(tostring(resultChannel:getCount()), 10,10)
end
